<template>
  <v-app class="accountantDiagram">
    <div class="accountantDiagram__title">
      <h1>Диаграмма</h1>
    </div>
    <div class="accountantDiagram__subtitle">
      <h2>Нажмите для получения диаграммы</h2>
    </div>

    <v-dialog v-model="dialog" max-width="500px">
      <template v-slot:activator="{ on, attrs }">
        <v-btn class="accountantDiagram__btn" v-bind="attrs" v-on="on" style="margin-right: auto">Создать</v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">{{ "Получить диаграмму" }}</span>
        </v-card-title>

        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="12">
                <v-text-field v-model="dialogItem.year" item-value="year" label="Год"></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="#AFFFCF" @click="close">
            Закрыть
          </v-btn>
          <v-btn color="#AFFFCF" @click="requestReport">
            Получить диаграмму
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-app>
</template>

<script>
import axios from "axios";

export default {
  name: "AccountantDiagram",
  data() {
    return {
      dialog: false,
      dialogItem: {
        year: 'YYYY',
      },
    }
  },

  methods: {
    async fetchReport(item) {
      axios
          .post(this.$root.globalVar + '/diagram/accountant/' + item.year, {
            year: item.year
          }, {
            responseType: "blob"
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
          .then(response => {
            console.log("Success", response);
            const blob = new Blob([response.data], {type: 'application/pdf'});
            console.log(blob)
            const objectUrl = URL.createObjectURL(blob);
            console.log(objectUrl);
            const downFile = document.createElement('a')
            downFile.href = objectUrl;
            downFile.download = 'diagram.png';
            document.body.appendChild(downFile);
            downFile.click();
          })
    },

    close() {
      this.dialog = false
    },

    requestReport() {
      this.fetchReport(this.dialogItem)
      this.dialog = false
    }
  }
}
</script>

<style lang="scss" scoped>
.accountantDiagram {
  &__title {
    margin: 60px 0 30px 0;
    text-align: center;
  }

  &__subtitle {
    margin: 0 0 20px 50px
  }

  &__btn {
    margin-left: 50px;
  }
}
</style>